using System;
using System.Drawing;
using System.Collections;
// using System.ComponentModel;
using System.Windows.Forms;
// using System.Data;

using System.Globalization;


using System.IO;
// using System.Xml;
using System.Net;
using System.Threading;
using System.Text;
using System.Web;

// using mshtml;


namespace RLExport
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class frmIntro : System.Windows.Forms.Form
	{
		DateTime curDate;
		DateTime startDate;
		DateTime endDate;

		private ArrayList runs = new ArrayList();


		private System.Net.CookieContainer sessionCookies = new CookieContainer();

		private string viewStateDate = string.Empty;

		private enum InstallState
		{
			Intro,
			Login,
			SelectDate,
			DefaultRunning,
			Finished
		}


		private InstallState mInstallState = InstallState.Intro;
		private bool bSaveComplete = false;

		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Panel pnlIntro;
		private System.Windows.Forms.Button btnExit;
		private System.Windows.Forms.Button btnNext;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.TextBox txtUsername;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.TextBox txtPassword;
		private System.Windows.Forms.Panel pnlLogin;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.DateTimePicker pkrStart;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.DateTimePicker pkrEnd;
		private System.Windows.Forms.Panel pnlDateRange;
		private System.Windows.Forms.Label label11;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.Label lblCurrentDate;
		private System.Windows.Forms.Label label12;
		private System.Windows.Forms.Label label13;
		private System.Windows.Forms.Label lblTargetDate;
		private System.Windows.Forms.Panel pnlRunning;
		private System.Windows.Forms.Panel pnlFile;
		private System.Windows.Forms.Label label14;
		private System.Windows.Forms.Label label15;
		private System.Windows.Forms.FolderBrowserDialog dlgFolder;
		private System.Windows.Forms.TextBox txtFilePath;
		private System.Windows.Forms.Button btnBrowse;
		private System.Windows.Forms.ListView lvRuns;
		private System.Windows.Forms.ColumnHeader clmDate;
		private System.Windows.Forms.ColumnHeader clmRunId;
		private System.Windows.Forms.ColumnHeader clmIntervalId;
		private System.Windows.Forms.ColumnHeader clmActivityType;
		private System.Windows.Forms.ColumnHeader clmRunType;
		private System.Windows.Forms.ColumnHeader clmDuration;
		private System.Windows.Forms.ColumnHeader clmDistance;
		private System.Windows.Forms.ColumnHeader clmUnit;
		private System.Windows.Forms.ColumnHeader clmComment;
		private System.Windows.Forms.ColumnHeader clmWeather;
		private System.Windows.Forms.ColumnHeader clmShoes;
		private System.Windows.Forms.ColumnHeader clmIntervalComment;
		private System.Windows.Forms.ColumnHeader clmCourse;
		private System.Windows.Forms.Label label16;
		private System.Windows.Forms.Label lblVersion;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public frmIntro()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			//
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.pnlIntro = new System.Windows.Forms.Panel();
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.btnNext = new System.Windows.Forms.Button();
			this.btnExit = new System.Windows.Forms.Button();
			this.pnlLogin = new System.Windows.Forms.Panel();
			this.txtPassword = new System.Windows.Forms.TextBox();
			this.label6 = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.txtUsername = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.pnlDateRange = new System.Windows.Forms.Panel();
			this.label7 = new System.Windows.Forms.Label();
			this.pkrStart = new System.Windows.Forms.DateTimePicker();
			this.label8 = new System.Windows.Forms.Label();
			this.label9 = new System.Windows.Forms.Label();
			this.pkrEnd = new System.Windows.Forms.DateTimePicker();
			this.pnlRunning = new System.Windows.Forms.Panel();
			this.lvRuns = new System.Windows.Forms.ListView();
			this.clmDate = new System.Windows.Forms.ColumnHeader();
			this.clmRunId = new System.Windows.Forms.ColumnHeader();
			this.clmIntervalId = new System.Windows.Forms.ColumnHeader();
			this.clmActivityType = new System.Windows.Forms.ColumnHeader();
			this.clmRunType = new System.Windows.Forms.ColumnHeader();
			this.clmDuration = new System.Windows.Forms.ColumnHeader();
			this.clmDistance = new System.Windows.Forms.ColumnHeader();
			this.clmUnit = new System.Windows.Forms.ColumnHeader();
			this.clmComment = new System.Windows.Forms.ColumnHeader();
			this.clmWeather = new System.Windows.Forms.ColumnHeader();
			this.clmShoes = new System.Windows.Forms.ColumnHeader();
			this.clmIntervalComment = new System.Windows.Forms.ColumnHeader();
			this.clmCourse = new System.Windows.Forms.ColumnHeader();
			this.label13 = new System.Windows.Forms.Label();
			this.label12 = new System.Windows.Forms.Label();
			this.label10 = new System.Windows.Forms.Label();
			this.label11 = new System.Windows.Forms.Label();
			this.lblCurrentDate = new System.Windows.Forms.Label();
			this.lblTargetDate = new System.Windows.Forms.Label();
			this.pnlFile = new System.Windows.Forms.Panel();
			this.txtFilePath = new System.Windows.Forms.TextBox();
			this.label14 = new System.Windows.Forms.Label();
			this.label15 = new System.Windows.Forms.Label();
			this.btnBrowse = new System.Windows.Forms.Button();
			this.dlgFolder = new System.Windows.Forms.FolderBrowserDialog();
			this.label16 = new System.Windows.Forms.Label();
			this.lblVersion = new System.Windows.Forms.Label();
			this.pnlIntro.SuspendLayout();
			this.pnlLogin.SuspendLayout();
			this.pnlDateRange.SuspendLayout();
			this.pnlRunning.SuspendLayout();
			this.pnlFile.SuspendLayout();
			this.SuspendLayout();
			// 
			// pnlIntro
			// 
			this.pnlIntro.BackColor = System.Drawing.SystemColors.Window;
			this.pnlIntro.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pnlIntro.Controls.Add(this.label2);
			this.pnlIntro.Controls.Add(this.label1);
			this.pnlIntro.Location = new System.Drawing.Point(624, 112);
			this.pnlIntro.Name = "pnlIntro";
			this.pnlIntro.Size = new System.Drawing.Size(456, 224);
			this.pnlIntro.TabIndex = 0;
			this.pnlIntro.Visible = false;
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(64, 88);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(328, 88);
			this.label2.TabIndex = 1;
			this.label2.Text = "This tool will allow you to export your data in a portable format.";
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(8, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(336, 23);
			this.label1.TabIndex = 0;
			this.label1.Text = "Welcome to the Running-log.com Export Wizard";
			// 
			// btnNext
			// 
			this.btnNext.Location = new System.Drawing.Point(376, 240);
			this.btnNext.Name = "btnNext";
			this.btnNext.TabIndex = 1;
			this.btnNext.Text = "Next >";
			this.btnNext.Click += new System.EventHandler(this.btnNext_Click);
			// 
			// btnExit
			// 
			this.btnExit.Location = new System.Drawing.Point(8, 240);
			this.btnExit.Name = "btnExit";
			this.btnExit.TabIndex = 1;
			this.btnExit.Text = "Exit";
			this.btnExit.Click += new System.EventHandler(this.btnExit_Click);
			// 
			// pnlLogin
			// 
			this.pnlLogin.BackColor = System.Drawing.SystemColors.Window;
			this.pnlLogin.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pnlLogin.Controls.Add(this.txtPassword);
			this.pnlLogin.Controls.Add(this.label6);
			this.pnlLogin.Controls.Add(this.label5);
			this.pnlLogin.Controls.Add(this.txtUsername);
			this.pnlLogin.Controls.Add(this.label3);
			this.pnlLogin.Controls.Add(this.label4);
			this.pnlLogin.Location = new System.Drawing.Point(600, 296);
			this.pnlLogin.Name = "pnlLogin";
			this.pnlLogin.Size = new System.Drawing.Size(456, 224);
			this.pnlLogin.TabIndex = 2;
			this.pnlLogin.Visible = false;
			// 
			// txtPassword
			// 
			this.txtPassword.Location = new System.Drawing.Point(176, 112);
			this.txtPassword.Name = "txtPassword";
			this.txtPassword.PasswordChar = '*';
			this.txtPassword.Size = new System.Drawing.Size(144, 20);
			this.txtPassword.TabIndex = 5;
			this.txtPassword.Text = "guest";
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(88, 112);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(80, 23);
			this.label6.TabIndex = 4;
			this.label6.Text = "Password:";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(88, 88);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(80, 23);
			this.label5.TabIndex = 3;
			this.label5.Text = "Username:";
			// 
			// txtUsername
			// 
			this.txtUsername.Location = new System.Drawing.Point(176, 88);
			this.txtUsername.Name = "txtUsername";
			this.txtUsername.Size = new System.Drawing.Size(144, 20);
			this.txtUsername.TabIndex = 2;
			this.txtUsername.Text = "johndoe";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(64, 48);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(328, 32);
			this.label3.TabIndex = 1;
			this.label3.Text = "Please provide the username and password you use when logging into running-log.co" +
				"m";
			// 
			// label4
			// 
			this.label4.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label4.Location = new System.Drawing.Point(8, 16);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(336, 23);
			this.label4.TabIndex = 0;
			this.label4.Text = "Log-In";
			// 
			// pnlDateRange
			// 
			this.pnlDateRange.BackColor = System.Drawing.SystemColors.Window;
			this.pnlDateRange.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pnlDateRange.Controls.Add(this.label7);
			this.pnlDateRange.Controls.Add(this.pkrStart);
			this.pnlDateRange.Controls.Add(this.label8);
			this.pnlDateRange.Controls.Add(this.label9);
			this.pnlDateRange.Controls.Add(this.pkrEnd);
			this.pnlDateRange.Location = new System.Drawing.Point(464, 0);
			this.pnlDateRange.Name = "pnlDateRange";
			this.pnlDateRange.Size = new System.Drawing.Size(456, 224);
			this.pnlDateRange.TabIndex = 0;
			this.pnlDateRange.Visible = false;
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(72, 88);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(72, 23);
			this.label7.TabIndex = 2;
			this.label7.Text = "Start date:";
			// 
			// pkrStart
			// 
			this.pkrStart.Location = new System.Drawing.Point(168, 88);
			this.pkrStart.MinDate = new System.DateTime(2000, 1, 1, 0, 0, 0, 0);
			this.pkrStart.Name = "pkrStart";
			this.pkrStart.TabIndex = 1;
			this.pkrStart.Value = new System.DateTime(2005, 1, 25, 0, 0, 0, 0);
			// 
			// label8
			// 
			this.label8.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label8.Location = new System.Drawing.Point(8, 16);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(336, 23);
			this.label8.TabIndex = 0;
			this.label8.Text = "Select the date range you would like to export";
			// 
			// label9
			// 
			this.label9.Location = new System.Drawing.Point(72, 120);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(72, 23);
			this.label9.TabIndex = 2;
			this.label9.Text = "End date:";
			// 
			// pkrEnd
			// 
			this.pkrEnd.Location = new System.Drawing.Point(168, 120);
			this.pkrEnd.MaxDate = new System.DateTime(2005, 11, 29, 0, 0, 0, 0);
			this.pkrEnd.MinDate = new System.DateTime(2000, 1, 1, 0, 0, 0, 0);
			this.pkrEnd.Name = "pkrEnd";
			this.pkrEnd.TabIndex = 1;
			this.pkrEnd.Value = new System.DateTime(2005, 1, 29, 0, 0, 0, 0);
			// 
			// pnlRunning
			// 
			this.pnlRunning.BackColor = System.Drawing.SystemColors.Window;
			this.pnlRunning.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pnlRunning.Controls.Add(this.lvRuns);
			this.pnlRunning.Controls.Add(this.label13);
			this.pnlRunning.Controls.Add(this.label12);
			this.pnlRunning.Controls.Add(this.label10);
			this.pnlRunning.Controls.Add(this.label11);
			this.pnlRunning.Controls.Add(this.lblCurrentDate);
			this.pnlRunning.Controls.Add(this.lblTargetDate);
			this.pnlRunning.Location = new System.Drawing.Point(0, 0);
			this.pnlRunning.Name = "pnlRunning";
			this.pnlRunning.Size = new System.Drawing.Size(456, 224);
			this.pnlRunning.TabIndex = 0;
			this.pnlRunning.Visible = false;
			// 
			// lvRuns
			// 
			this.lvRuns.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																					 this.clmDate,
																					 this.clmRunId,
																					 this.clmIntervalId,
																					 this.clmActivityType,
																					 this.clmRunType,
																					 this.clmDuration,
																					 this.clmDistance,
																					 this.clmUnit,
																					 this.clmComment,
																					 this.clmWeather,
																					 this.clmShoes,
																					 this.clmIntervalComment,
																					 this.clmCourse});
			this.lvRuns.FullRowSelect = true;
			this.lvRuns.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
			this.lvRuns.Location = new System.Drawing.Point(16, 96);
			this.lvRuns.MultiSelect = false;
			this.lvRuns.Name = "lvRuns";
			this.lvRuns.Size = new System.Drawing.Size(424, 112);
			this.lvRuns.TabIndex = 5;
			this.lvRuns.View = System.Windows.Forms.View.Details;
			// 
			// clmDate
			// 
			this.clmDate.Text = "Date";
			// 
			// clmRunId
			// 
			this.clmRunId.Text = "Workout ID";
			// 
			// clmIntervalId
			// 
			this.clmIntervalId.Text = "Interval ID";
			// 
			// clmActivityType
			// 
			this.clmActivityType.Text = "Activity";
			// 
			// clmRunType
			// 
			this.clmRunType.Text = "Run Type";
			// 
			// clmDuration
			// 
			this.clmDuration.Text = "Duration";
			// 
			// clmDistance
			// 
			this.clmDistance.Text = "Distance";
			// 
			// clmUnit
			// 
			this.clmUnit.Text = "Unit";
			// 
			// clmComment
			// 
			this.clmComment.Text = "Comment";
			// 
			// clmWeather
			// 
			this.clmWeather.Text = "Weather";
			// 
			// clmShoes
			// 
			this.clmShoes.Text = "Shoes";
			// 
			// clmIntervalComment
			// 
			this.clmIntervalComment.Text = "Interval Comment";
			// 
			// clmCourse
			// 
			this.clmCourse.Text = "Course";
			// 
			// label13
			// 
			this.label13.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label13.Location = new System.Drawing.Point(176, 48);
			this.label13.Name = "label13";
			this.label13.Size = new System.Drawing.Size(72, 16);
			this.label13.TabIndex = 4;
			this.label13.Text = "Target Date:";
			// 
			// label12
			// 
			this.label12.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label12.Location = new System.Drawing.Point(16, 80);
			this.label12.Name = "label12";
			this.label12.Size = new System.Drawing.Size(56, 16);
			this.label12.TabIndex = 3;
			this.label12.Text = "Results:";
			// 
			// label10
			// 
			this.label10.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label10.Location = new System.Drawing.Point(16, 48);
			this.label10.Name = "label10";
			this.label10.Size = new System.Drawing.Size(80, 16);
			this.label10.TabIndex = 2;
			this.label10.Text = "Current Date:";
			// 
			// label11
			// 
			this.label11.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label11.ForeColor = System.Drawing.SystemColors.ControlText;
			this.label11.Location = new System.Drawing.Point(8, 16);
			this.label11.Name = "label11";
			this.label11.Size = new System.Drawing.Size(336, 23);
			this.label11.TabIndex = 0;
			this.label11.Text = "Your records are currently being exported";
			// 
			// lblCurrentDate
			// 
			this.lblCurrentDate.Location = new System.Drawing.Point(104, 48);
			this.lblCurrentDate.Name = "lblCurrentDate";
			this.lblCurrentDate.Size = new System.Drawing.Size(64, 16);
			this.lblCurrentDate.TabIndex = 2;
			this.lblCurrentDate.Text = "00/00/0000";
			// 
			// lblTargetDate
			// 
			this.lblTargetDate.Location = new System.Drawing.Point(256, 48);
			this.lblTargetDate.Name = "lblTargetDate";
			this.lblTargetDate.Size = new System.Drawing.Size(64, 16);
			this.lblTargetDate.TabIndex = 2;
			this.lblTargetDate.Text = "00/00/0000";
			// 
			// pnlFile
			// 
			this.pnlFile.BackColor = System.Drawing.SystemColors.Window;
			this.pnlFile.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pnlFile.Controls.Add(this.txtFilePath);
			this.pnlFile.Controls.Add(this.label14);
			this.pnlFile.Controls.Add(this.label15);
			this.pnlFile.Controls.Add(this.btnBrowse);
			this.pnlFile.Location = new System.Drawing.Point(136, 288);
			this.pnlFile.Name = "pnlFile";
			this.pnlFile.Size = new System.Drawing.Size(456, 224);
			this.pnlFile.TabIndex = 3;
			this.pnlFile.Visible = false;
			// 
			// txtFilePath
			// 
			this.txtFilePath.Location = new System.Drawing.Point(64, 104);
			this.txtFilePath.Name = "txtFilePath";
			this.txtFilePath.Size = new System.Drawing.Size(208, 20);
			this.txtFilePath.TabIndex = 2;
			this.txtFilePath.Text = "";
			// 
			// label14
			// 
			this.label14.Location = new System.Drawing.Point(64, 88);
			this.label14.Name = "label14";
			this.label14.Size = new System.Drawing.Size(328, 16);
			this.label14.TabIndex = 1;
			this.label14.Text = "Select the folder you would like the data stored in";
			// 
			// label15
			// 
			this.label15.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label15.Location = new System.Drawing.Point(8, 16);
			this.label15.Name = "label15";
			this.label15.Size = new System.Drawing.Size(336, 23);
			this.label15.TabIndex = 0;
			this.label15.Text = "Export Complete";
			// 
			// btnBrowse
			// 
			this.btnBrowse.BackColor = System.Drawing.SystemColors.Control;
			this.btnBrowse.Location = new System.Drawing.Point(272, 104);
			this.btnBrowse.Name = "btnBrowse";
			this.btnBrowse.Size = new System.Drawing.Size(75, 24);
			this.btnBrowse.TabIndex = 1;
			this.btnBrowse.Text = "Browse...";
			this.btnBrowse.Click += new System.EventHandler(this.btnBrowse_Click);
			// 
			// label16
			// 
			this.label16.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label16.Location = new System.Drawing.Point(144, 248);
			this.label16.Name = "label16";
			this.label16.Size = new System.Drawing.Size(40, 16);
			this.label16.TabIndex = 4;
			this.label16.Text = "Version:";
			// 
			// lblVersion
			// 
			this.lblVersion.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblVersion.Location = new System.Drawing.Point(184, 248);
			this.lblVersion.Name = "lblVersion";
			this.lblVersion.Size = new System.Drawing.Size(152, 16);
			this.lblVersion.TabIndex = 4;
			this.lblVersion.Text = "Version:";
			// 
			// frmIntro
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(456, 276);
			this.Controls.Add(this.label16);
			this.Controls.Add(this.pnlFile);
			this.Controls.Add(this.pnlRunning);
			this.Controls.Add(this.pnlDateRange);
			this.Controls.Add(this.pnlLogin);
			this.Controls.Add(this.btnNext);
			this.Controls.Add(this.pnlIntro);
			this.Controls.Add(this.btnExit);
			this.Controls.Add(this.lblVersion);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.Name = "frmIntro";
			this.Text = "Running-Log.com Export Wizard";
			this.Load += new System.EventHandler(this.frmIntro_Load);
			this.Closed += new System.EventHandler(this.frmIntro_Closed);
			this.pnlIntro.ResumeLayout(false);
			this.pnlLogin.ResumeLayout(false);
			this.pnlDateRange.ResumeLayout(false);
			this.pnlRunning.ResumeLayout(false);
			this.pnlFile.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new frmIntro());
		}


		private void btnExit_Click(object sender, System.EventArgs e)
		{
			if (InstallState.Intro == this.mInstallState || this.bSaveComplete)
			{
				Application.Exit();
				return;
			}

			Console.Out.WriteLine(this.mInstallState);

			DialogResult dResult = MessageBox.Show ("If you exit now all unsaved changes will be lost. Are you sure you want to exit?", "Confirm Exit",	MessageBoxButtons.YesNo);
			
			if (dResult.Equals(DialogResult.Yes))
			{
				Environment.Exit(0);
				return;
			}
		}


		private void btnNext_Click(object sender, System.EventArgs e)
		{
			switch (this.mInstallState)
			{
				case InstallState.Intro:
					this.switchIntro();
					break;
				case InstallState.Login:
					this.switchLogin();
					break;
				case InstallState.SelectDate:
					this.switchSelectDate();
					break;
				case InstallState.Finished:
					this.saveFile();
					break;
			}
		}


		private void frmIntro_Load(object sender, System.EventArgs e)
		{
			Point pt = new Point(0,0);
			this.pnlIntro.Location = pt;
			this.pnlIntro.Visible = true;

			this.pnlLogin.Location = pt;
			this.pnlRunning.Location = pt;

			this.pnlDateRange.Visible = true;

			this.lblVersion.Text = Application.ProductVersion;
		}


		private void switchIntro()
		{	
			this.pnlLogin.Visible = true;
			this.pnlIntro.Visible = false;

			this.btnNext.Text = "Login";
			this.mInstallState = InstallState.Login;
		}


		private void switchLogin()
		{
			this.startLogin();
		}

		private string getLoginViewState()
		{
			HttpWebResponse response = this.navigateBrowser("http://running-log.com/login.aspx");

			StreamReader stream = new StreamReader(response.GetResponseStream());
			string htm = stream.ReadToEnd();

			stream.Close();
			response.Close();
			
			return this.parseViewState(ref htm);
		}


		private string parseViewState(ref string htm)
		{
			string viewstateTagStart = "__VIEWSTATE\" value=\"";
			char viewstateTagEnd = '"';
			int viewstateTagLength = viewstateTagStart.Length;

			int startpos = htm.IndexOf(viewstateTagStart);
			int endpos   = htm.IndexOf(viewstateTagEnd,startpos + viewstateTagLength);

			int viewstateLength = (endpos) - (startpos + viewstateTagLength);

			string pageViewState = htm.Substring((startpos + viewstateTagLength),viewstateLength);

			return pageViewState;
		}

		private void startLogin()
		{
			this.btnNext.Enabled = false;
			this.Cursor = Cursors.WaitCursor;

			string viewstate = getLoginViewState();

			Hashtable postData = new Hashtable();

			postData.Add("__VIEWSTATE",viewstate);

			postData.Add("txtUsername",this.txtUsername.Text);
			postData.Add("txtPassword",this.txtPassword.Text);
			postData.Add("btnLogin","Login");

			HttpWebResponse response = navigatePost("http://running-log.com/login.aspx",postData);
			response.Close();

			this.btnNext.Enabled = true;
			this.Cursor = Cursors.Default;
			this.pnlLogin.Visible = false;

			this.pnlDateRange.Visible = true;
			Point pt = this.pnlDateRange.Location;
			pt.X = 0;
			pt.Y = 0;
			this.pnlDateRange.Location = pt;

			this.mInstallState = InstallState.SelectDate;
			this.btnNext.Text = "Start Export";

			DateTime dt = DateTime.Now;

			this.pkrEnd.MaxDate = new DateTime(dt.Year,dt.Month,dt.Day,23,59,59,999);
			this.pkrEnd.Value = dt.Date;
			this.pkrStart.Value = dt.Date;
			this.pkrStart.MaxDate = dt.Date;
		}

		private HttpWebResponse navigatePost(string url, Hashtable data)
		{
			HttpWebRequest request = (HttpWebRequest)WebRequest.Create(url);

			request.Method = "POST";
			request.ContentType = "application/x-www-form-urlencoded";

			StringBuilder dataString = new StringBuilder();
			foreach (object key in data.Keys)
			{
				string fname = (string)key;
				string fval  = (string)data[key];
				fname = HttpUtility.UrlEncode(fname);
				fval = HttpUtility.UrlEncode(fval);

				dataString.Append(String.Format("{0}={1}&",fname,fval));
			}

			request.AllowAutoRedirect = false;

			request.CookieContainer = this.sessionCookies;

			StreamWriter sr = new StreamWriter(request.GetRequestStream());
			sr.Write(dataString.ToString());
			sr.Close();

			return (HttpWebResponse) request.GetResponse();
		}

		private HttpWebResponse navigateBrowser(string url)
		{			    
			HttpWebRequest request = (HttpWebRequest)WebRequest.Create(url);

			request.AllowAutoRedirect = false;

			request.CookieContainer = this.sessionCookies;

			return (HttpWebResponse) request.GetResponse();
		}

		private void switchSelectDate()
		{
			this.pnlDateRange.Visible = false;
			this.pnlRunning.Visible = true;
			this.btnNext.Visible = false;
			startRunning();
		}

		private void startRunning()
		{
			this.lblTargetDate.Text  = this.pkrEnd.Value.ToString("d");
			this.lblCurrentDate.Text = this.pkrStart.Value.ToString("d");

			this.startDate = this.pkrStart.Value;
			this.endDate = this.pkrEnd.Value;

			curDate = this.pkrStart.Value;

			this.getYear();
		}

		private void getYear()
		{	
			HttpWebResponse response = this.navigateBrowser("http://running-log.com/personal/reports/yearly.aspx?Year=" + curDate.Year);

			this.mInstallState = InstallState.DefaultRunning;

			StreamReader stream = new StreamReader(response.GetResponseStream());

			string htm = stream.ReadToEnd();

			stream.Close();
			response.Close();

			int pos = htm.IndexOf("id=\"tblMileage\"");

			for (int i = 0; i < 12; i++)
			{
				pos = htm.IndexOf("<td",pos);
				pos = htm.IndexOf(">",pos);

				if (this.curDate.Year == this.startDate.Year
					&& i + 1 < startDate.Month)
					continue;

				if(this.curDate.Year == this.endDate.Year
					&& i + 1 > endDate.Month)
				{
					this.finishedRunning();
					return;
				}

				int numberstart = pos + 1;
				int numberend = htm.IndexOf("<",numberstart);

				float numbval = float.Parse(htm.Substring(numberstart,numberend - numberstart));

			
				if (numbval == 0)
				{
					if (this.curDate.Year == this.endDate.Year
						&& this.curDate.Month == this.endDate.Month)
					{
						this.finishedRunning();
						return;
					}

					this.curDate = this.curDate.AddMonths(1);
					this.lblCurrentDate.Text = this.curDate.ToString("d");
					Application.DoEvents();
					Thread.Sleep(1);
					continue;
				}

				this.getMonth();
			}

			if (this.curDate.CompareTo(this.endDate) <= 0)
				this.getYear();
		}

		private void finishedRunning()
		{	
			this.mInstallState = InstallState.Finished;
			this.pnlDateRange.Visible = false;
			this.pnlRunning.Visible = false;
			this.pnlFile.Visible = true;
			this.pnlFile.Location = new Point(0,0);

			this.btnNext.Visible = true;
			this.btnNext.Enabled = true;
			this.btnNext.Text = "Save";

			this.txtFilePath.Text = Application.StartupPath;

		}

		private void saveFile()
		{
			string filePath = this.txtFilePath.Text;
			if (!filePath.EndsWith(@"\"))
				filePath += @"\";
			StreamWriter sr = new StreamWriter(filePath + @"rlexport.txt");

			StringBuilder columnHeaders = new StringBuilder();
			for (int i = 0; i < this.lvRuns.Columns.Count; i ++)
			{
				columnHeaders.Append(this.lvRuns.Columns[i].Text + "\t");
			}
			sr.WriteLine(columnHeaders.ToString());

			foreach(object ob in this.runs)
			{
				Run rn = (Run) ob;
				sr.WriteLine(rn.ToString());
			}
			sr.Close();

			MessageBox.Show(this,"Save Complete!");
			this.bSaveComplete = true;
		}

//		private long findIndexOfStringInStream(Stream stream, string findstr)
//		{
//			char[] findA = findstr.ToCharArray();
//
//			char mychar = (char)stream.ReadByte();
//
//			while(mychar != 0)
//			{
//				if (!mychar.Equals(findA[0]))
//				{
//					mychar = (char)stream.ReadByte();
//				}
//
//				int index = 0;
//				long retPos = stream.Position;
//
//				while(findA[index].Equals(mychar))
//				{
//					if (findstr.Length == index - 1)
//						return retPos;
//
//					index++;
//					mychar = (char)stream.ReadByte();
//				}
//
//				mychar = (char)stream.ReadByte();
//			}
//
//			return -1;
//		}

		private void getMonth()
		{
			if (this.viewStateDate.Length < 1)
			{
				HttpWebResponse tmpresponse = this.navigateBrowser("http://running-log.com/personal/views/monthly.aspx");		

				StreamReader tmpsr = new StreamReader(tmpresponse.GetResponseStream());
				String tmphtm = tmpsr.ReadToEnd();
				tmpsr.Close();
				tmpresponse.Close();

				this.viewStateDate = this.parseViewState(ref tmphtm);
			}

			Hashtable postData = new Hashtable();
			postData.Add("__VIEWSTATE",this.viewStateDate);
			postData.Add("__EVENTTARGET","calMonth");

			DateTime janFirst = new DateTime(2000,1,1);
			TimeSpan span = curDate.Subtract(janFirst);
			
			postData.Add("__EVENTARGUMENT","V" + span.Days);

			HttpWebResponse response = this.navigatePost("http://running-log.com/personal/views/monthly.aspx",postData);
			StreamReader sr = new StreamReader(response.GetResponseStream());
			String htm = sr.ReadToEnd();
			sr.Close();
			response.Close();

			
			int startpos = htm.IndexOf("id=\"calMonth\"");
			startpos = htm.IndexOf("</table>",startpos);
			startpos = htm.IndexOf("</tr>",startpos);
			startpos = htm.IndexOf("</tr>",startpos);

			int endpos = htm.IndexOf("</p>",startpos);

			int pos = startpos;
			int day = 0;
			while (pos < endpos)
			{
				string tdline =  "<td class=\"content-area\" align=\"Left\" valign=\"Top\" width=\"14%\">";
				string tdend  =  "</td>";

				pos = htm.IndexOf(tdline,pos + 1);

				if (pos > endpos || pos < 0)
					break;

				int endtd = htm.IndexOf(tdend,pos - 1);

				string tdInnerHtm = htm.Substring(pos + tdline.Length,(endtd - pos) - tdline.Length);
		
				if (tdInnerHtm.Length < 1)
					continue;

				day++;
				if (day < this.curDate.Day)
					continue;
				
				int apos = tdInnerHtm.IndexOf("<a");
				this.lvRuns.BeginUpdate();
				while (apos > -1)
				{
					string hrefstring = "href=\"";
					int hrefpos = tdInnerHtm.IndexOf(hrefstring,apos);
					int hrefend = tdInnerHtm.IndexOf("\"",hrefpos + hrefstring.Length);
					// "http://running-log.com/personal/views/workout.aspx?WorkoutID=590756&amp;"
						
					string linkstr = tdInnerHtm.Substring(hrefpos,hrefend - hrefpos);

					string workoutidstr = "WorkoutID=";
					int workoutpos = linkstr.IndexOf(workoutidstr) + workoutidstr.Length;
					int workoutend = linkstr.IndexOf('&',workoutpos);

					string workoutstr = linkstr.Substring(workoutpos,workoutend - workoutpos);
					int workoutid = int.Parse(workoutstr);

					int runtypeStart = tdInnerHtm.IndexOf('>',hrefpos) + 1;
					int runtypeEnd = tdInnerHtm.IndexOf('<',runtypeStart);

					string runtype = tdInnerHtm.Substring(runtypeStart,runtypeEnd - runtypeStart);

					if (runtype.Equals("Comments"))
					{
						apos = tdInnerHtm.IndexOf("<a",hrefend);
						continue;
					}

					this.getWorkout(workoutid);

					apos = tdInnerHtm.IndexOf("<a",hrefend);
				}

				this.lvRuns.EndUpdate();

				if (this.curDate.Date.CompareTo(this.endDate.Date) == 0)
				{
					this.finishedRunning();
					return;
				}

				this.curDate = this.curDate.AddDays(1);
				this.lblCurrentDate.Text = this.curDate.ToString("d");
				Application.DoEvents();
				System.Threading.Thread.Sleep(1);

			
			}
		}

		private void getWorkout(int workoutid)
		{

			HttpWebResponse response = this.navigateBrowser("http://running-log.com/personal/views/workout.aspx?WorkoutID=" + workoutid);

			StreamReader sr = new StreamReader(response.GetResponseStream());
			String htm = sr.ReadToEnd();
			sr.Close();
			response.Close();

			string workoutTableStart = "<table class=\"content-area\" width=\"75%\" align=\"center\" border=\"0\">";
			string workoutTableEnd = "<p align=\"center\">";

			string spanEnd = "</span>";
			string dateStart = "<span id=\"lblDate\">";
			string weatherStart = "<span id=\"lblWeather\">";
			string commentsStart = "<span id=\"lblComments\">";


			int woStartIdx = htm.IndexOf(workoutTableStart);
			int woEndIdx = htm.IndexOf(workoutTableEnd,woStartIdx);

			int dateStartIdx = htm.IndexOf(dateStart,woStartIdx);
			dateStartIdx	= htm.IndexOf('>',dateStartIdx) + 1;
			int dateEndIdx = htm.IndexOf(spanEnd,dateStartIdx);

			string mydate = htm.Substring(dateStartIdx,dateEndIdx - dateStartIdx).Trim().Replace("&nbsp;"," ");	
			
			string[] expectedDateFormats = {"d","g","MM/dd/yyyy HH:mmz"};

			System.IFormatProvider ifp = new CultureInfo("en-US");

			Cookie tzCookie = this.sessionCookies.GetCookies(response.ResponseUri)["TimeZone"];
			if (mydate.IndexOf(" ") > -1 && tzCookie != null)
			{
				mydate = DateTime.ParseExact(mydate,expectedDateFormats,ifp,DateTimeStyles.None).ToString("MM/dd/yyyy HH:mm");
				mydate += tzCookie.Value;
			}
			DateTime date = DateTime.ParseExact(mydate,expectedDateFormats,ifp,DateTimeStyles.None);


			int weatherStartIdx = htm.IndexOf(weatherStart,dateEndIdx);
			weatherStartIdx		= htm.IndexOf('>',weatherStartIdx) + 1;
			int weatherEndIdx	= htm.IndexOf(spanEnd,weatherStartIdx);

			string weather = htm.Substring(weatherStartIdx,weatherEndIdx - weatherStartIdx).Trim();

			int commentsStartIdx	= htm.IndexOf(commentsStart,weatherEndIdx);
			commentsStartIdx		= htm.IndexOf('>',commentsStartIdx) + 1;
			int commentsEndIdx		= htm.IndexOf(spanEnd,commentsStartIdx);

			string comments = htm.Substring(commentsStartIdx,commentsEndIdx - commentsStartIdx);
			comments = comments.Replace('\n',' ');
			comments = comments.Replace("\r",string.Empty);
			comments = comments.Replace("<br />",string.Empty);
			comments = comments.Trim();

			Run run = new Run();
			run.rundate = date;
			run.weather = weather;
			run.comment = comments;
			run.runid = workoutid;


			string pstart = "<p>";
			string pend  = "<p align=\"center\">";

			int pstartIdx = htm.IndexOf(pstart,commentsEndIdx);
			int pendIdx   = htm.IndexOf(pend,pstartIdx);

			string intervalsHtm = htm.Substring(pstartIdx,pendIdx - pstartIdx);

			run.intervals = this.getIntervals(ref intervalsHtm);

			this.runs.Add(run);
			this.lvRuns.Items.AddRange(run.getListViewItem());
		}

		private Interval[] getIntervals(ref string htm)
		{
			ArrayList intervals = new ArrayList();

			int firstTableIdx = htm.IndexOf("<table");
			int intervalTableIdx = htm.IndexOf("<table",firstTableIdx + 1);

			int intervalId = 0;
			while(intervalTableIdx > -1)
			{
				Interval interval = new Interval();
				interval.id = intervalId;
				
				int activityTypeStart = htm.IndexOf("<td",intervalTableIdx);
				activityTypeStart = htm.IndexOf(">",activityTypeStart) + 1;

				int activityTypeEnd = htm.IndexOf("<br />",activityTypeStart);

				interval.activityType = htm.Substring(activityTypeStart,activityTypeEnd - activityTypeStart).Trim();

				int runTypeStart = htm.IndexOf('>',activityTypeEnd) + 1;
				int runTypeEnd	 = htm.IndexOf('<',runTypeStart);

				interval.runType = htm.Substring(runTypeStart,runTypeEnd - runTypeStart).Trim();

				int courseStart = htm.IndexOf("<a",runTypeEnd);
				courseStart		= htm.IndexOf('>',courseStart) + 1;
				int courseEnd	= htm.IndexOf("</a>",courseStart);

				string course = htm.Substring(courseStart,courseEnd - courseStart);
				course = course.Replace('\n',' ');
				course = course.Replace("\r",string.Empty);
				course = course.Replace("<br>",string.Empty);
				course = course.Replace("<br />",string.Empty);
				course = course.Replace('\t',' ');
				course = course.Trim();
				interval.course = course;

				int intervalCommentStart = htm.IndexOf("</a>",courseEnd);
				intervalCommentStart = htm.IndexOf('>',intervalCommentStart) + 1;
				int intervalCommentEnd = htm.IndexOf("</td>",intervalCommentStart);

				string comment = htm.Substring(intervalCommentStart,intervalCommentEnd - intervalCommentStart);
				comment = comment.Replace('\n',' ');
				comment = comment.Replace("\r",string.Empty);
				comment = comment.Replace("<br>",string.Empty);
				comment = comment.Replace("<br />",string.Empty);
				comment = comment.Replace('\t',' ');
				comment = comment.Trim();
				interval.comment = comment;

				int distanceStart = htm.IndexOf("<td",intervalCommentEnd);
				distanceStart = htm.IndexOf('>',distanceStart);
				distanceStart = htm.IndexOf('\n',distanceStart) + 1;
				int distanceEnd = htm.IndexOf('\r',distanceStart);

				string distString = htm.Substring(distanceStart,distanceEnd - distanceStart).Trim();
				if (distString.Length > 0)
				{
					int distEnd = htm.IndexOf('&',distanceStart);
					interval.distance = float.Parse(htm.Substring(distanceStart,distEnd-distanceStart).Trim());

					int unitStart = htm.IndexOf(';',distEnd) + 1;
					int unitEnd	  = htm.IndexOf('<',unitStart);

					interval.unit = htm.Substring(unitStart,unitEnd - unitStart);
				}
				
				int timeStart = htm.IndexOf('\n',distanceEnd) + 1;
				int timeEnd   = htm.IndexOf("\r\n",timeStart);

				string duration = htm.Substring(timeStart,timeEnd - timeStart).Trim();
				duration = duration.Replace('\n',' ');
				duration = duration.Replace("\r",string.Empty);
				duration = duration.Replace("<br>",string.Empty);
				duration = duration.Replace("<br />",string.Empty);
				duration = duration.Trim();
				interval.duration = duration;

				int shoeStart = htm.IndexOf("<a", timeEnd);
				shoeStart = htm.IndexOf('>',shoeStart) + 1;
				int shoeEnd = htm.IndexOf('<',shoeStart);

				interval.shoes = htm.Substring(shoeStart,shoeEnd - shoeStart).Trim();

				intervals.Add(interval);
				intervalTableIdx = htm.IndexOf("<table",intervalTableIdx + 1);
				intervalId++;
			}

			return (Interval[]) intervals.ToArray(typeof(RLExport.Interval));
		}

		private void frmIntro_Closed(object sender, System.EventArgs e)
		{
			Environment.Exit(0);
		}


		private void btnBrowse_Click(object sender, System.EventArgs e)
		{
			this.dlgFolder.SelectedPath = this.txtFilePath.Text;
			DialogResult dr = this.dlgFolder.ShowDialog(this);
			if (dr == DialogResult.OK)
				this.txtFilePath.Text = this.dlgFolder.SelectedPath;
		}

		

	}

	public class Run
	{
		public int		runid		= 0;
		public DateTime	rundate		= DateTime.MinValue;
		public string	weather		= string.Empty;
		public string	comment		= string.Empty;

		public Interval[] intervals = null;

		public Run()
		{

		}

		public override string ToString()
		{
			StringBuilder sb = new StringBuilder();


			for (int i = 0; i < this.intervals.Length; i++)
			{
				sb.Append(rundate.ToString("MM/dd/yyyy HH:mmz")+ "\t");
				sb.Append(runid									+ "\t");
				sb.Append(intervals[i].id						+ "\t");
				sb.Append(intervals[i].activityType				+ "\t");
				sb.Append(intervals[i].runType					+ "\t");
				sb.Append(intervals[i].duration					+ "\t");
				sb.Append(intervals[i].distance					+ "\t");
				sb.Append(intervals[i].unit						+ "\t");
				sb.Append(comment								+ "\t");
				sb.Append(weather								+ "\t");
				sb.Append(intervals[i].shoes					+ "\t");
				sb.Append(intervals[i].comment					+ "\t");
				sb.Append(intervals[i].course					+ "\t");


				if (i < intervals.Length - 1)
					sb.Append("\r\n");
			}
			return sb.ToString();
		}

		public ListViewItem[] getListViewItem()
		{
			ArrayList lviA = new ArrayList();

			string[] ivals = this.ToString().Split('\n');

			for (int i = 0; i < ivals.Length; i++)
			{
				string[] ivalCols = ivals[i].Split('\t');
				ListViewItem lvi = new ListViewItem(ivalCols);
				lviA.Add(lvi);		
			}

			return (ListViewItem[]) lviA.ToArray(typeof(ListViewItem));
		}

	}

	public class Interval
	{
		public string	duration	= string.Empty;
		public string	shoes		= string.Empty;
		public string	unit		= string.Empty;
		public float	distance	= 0;

		public string	runType			= string.Empty;
		public string	activityType	= string.Empty;

		public string	comment			= string.Empty;

		public string	course			= string.Empty;

		public int		id				= 0;

		public Interval()
		{
		}
	}

	public enum RunType
	{
		NoType,
		Cooldown,
		Fartlek,
		Hills,
		Race,
		Recovery,
		Speed,
		Tempo,
		Training,
		Warmup
	}

	public enum ActivityType
	{
		Bike,
		Elliptical_Trainer,
		Lifting,
		Other,
		Rest_Day,
		Rowing,
		Run,
		Swim,
		Walk
	}

}
